package com.redhat.example.ejb;

import java.util.concurrent.Future;
import java.util.concurrent.atomic.AtomicLong;

import javax.ejb.AsyncResult;
import javax.ejb.Asynchronous;
import javax.ejb.Stateless;
import javax.ejb.TransactionAttribute;
import javax.ejb.TransactionAttributeType;

import org.jboss.logging.Logger;

@Stateless
public class RemoteEJBBean implements RemoteEJB {
    private static final Logger LOGGER = Logger.getLogger(RemoteEJBBean.class);
    
    private static AtomicLong counter = new AtomicLong(0);
    

    @Override
    @TransactionAttribute(TransactionAttributeType.NOT_SUPPORTED)
    public void execute1(Object o) {
        long current = counter.incrementAndGet();
        if(current %1000 == 0) LOGGER.info(current);
    }
    
    @Override
    @TransactionAttribute(TransactionAttributeType.NOT_SUPPORTED)
    public Object execute2(Object o) {
        long current = counter.incrementAndGet();
        if(current %1000 == 0) LOGGER.info(current);
        return o;
    }

    @Override
    @TransactionAttribute(TransactionAttributeType.NOT_SUPPORTED)
    @Asynchronous
    public void executeAsync1(Object o) {
        long current = counter.incrementAndGet();
        if(current %1000 == 0) LOGGER.info(current);
    }
    

    @Override
    @TransactionAttribute(TransactionAttributeType.NOT_SUPPORTED)
    @Asynchronous
    public Future<Object> executeAsync2(Object o) {
        long current = counter.incrementAndGet();
        if(current %1000 == 0) LOGGER.info(current);
        return new AsyncResult<Object>(o);
    }
    
    @Override
    @TransactionAttribute(TransactionAttributeType.NOT_SUPPORTED)
    public long get() {
        return counter.get();
    }

    @Override
    @TransactionAttribute(TransactionAttributeType.NOT_SUPPORTED)
    public void reset() {
        counter.set(0);
    }
}
