import java.lang.management.ManagementFactory;
import java.util.ArrayList;
import java.util.List;
import java.util.Properties;
import java.util.concurrent.atomic.AtomicLong;

import javax.management.MBeanServer;
import javax.management.ObjectName;
import javax.naming.Context;
import javax.naming.InitialContext;

import org.jboss.logging.Logger;

import com.redhat.example.ejb.RemoteEJB;

public class TestMainDBufferLeak {
    private static final Logger log = Logger.getLogger(TestMainDBufferLeak.class);

    // FIXME
    public static String providerIpPort = "127.0.0.1:4447";
//    public static String principal = "jboss";
//    public static String credential = "jbossjboss#2";

    private static final String JNDI_NAME = "/remote-async-void-slsb-dbuffer-leak-1.0.0/RemoteEJBBean!com.redhat.example.ejb.RemoteEJB";

    private static Context rootContext1;
    private static Context ejbContext1;

    private static AtomicLong invoked = new AtomicLong(0);

    public static void main(String[] args) throws Exception {
        log.info("******** START******** ");

        try {

            rootContext1 = new InitialContext(createUniqueNamedProperties());
            ejbContext1 = (Context) rootContext1.lookup("ejb:");

            RemoteEJB ejb = (RemoteEJB) ejbContext1.lookup(JNDI_NAME);
            ejb.reset();

            List<Thread> threads = new ArrayList<Thread>();

            for (int i = 0; i < 30; i++) {
                threads.add(new Thread(new Runner()));
            }
            for (Thread t : threads) {
                t.start();
            }
            for (Thread t : threads) {
                t.join();
            }

            long ejbCount = ejb.get();
            long invokedCount = invoked.get();

            log.infof("ejbCount = %,d", ejbCount);
            log.infof("invCount = %,d", invokedCount);

        } catch (Exception e) {
            log.error("EXCEPTION! ", e);
        } finally {
            ejbContext1.close();
            rootContext1.close();
        }
    }

    private static Properties createUniqueNamedProperties() {
        Properties jndiProperties = new Properties();
        String[] hostPort = providerIpPort.split(":");

        jndiProperties.put(Context.URL_PKG_PREFIXES, "org.jboss.ejb.client.naming");
        jndiProperties.put("org.jboss.ejb.client.scoped.context", "true");

        jndiProperties.put("remote.connectionprovider.create.options.org.xnio.Options.SSL_ENABLED", "false");
        jndiProperties.put("remote.connections", "default");
        jndiProperties.put("remote.connection.default.host", hostPort[0]);
        jndiProperties.put("remote.connection.default.port", hostPort[1]);
//        jndiProperties.put("remote.connection.default.username", principal);
//        jndiProperties.put("remote.connection.default.password", credential);
        jndiProperties.put("remote.connection.default.connect.options.org.xnio.Options.SASL_POLICY_NOANONYMOUS", "false");

        // jndiProperties.put("endpoint.create.options.org.xnio.Options.WORKER_READ_THREADS", "1");
        // jndiProperties.put("endpoint.create.options.org.xnio.Options.WORKER_WRITE_THREADS", "1");
        // jndiProperties.put("endpoint.create.options.org.xnio.Options.WORKER_TASK_CORE_THREADS", "4");
        // jndiProperties.put("endpoint.create.options.org.xnio.Options.WORKER_TASK_MAX_THREADS", "4");

        return jndiProperties;
    }

    public static class Runner implements Runnable {

        @Override
        public void run() {
            String object = "hogehoge";

            try {
                RemoteEJB ejb = (RemoteEJB) ejbContext1.lookup(JNDI_NAME);
                for (int i = 0; i < 1000000; i++) {

                    // ejb.execute1(object); // sync void

                    // if(!object.equals(ejb.execute2(object))) throw new RuntimeException(); // sync with return object

                    ejb.executeAsync1(object); // async void

                    // Future<Object> ret = ejb.executeAsync2(object); // async with return object
                    // if(!object.equals(ret.get())) throw new RuntimeException();

                    reportNativeBufferUsage(invoked.incrementAndGet());
                }
            } catch (Exception e) {
                log.error("", e);
            }
        }
    }

    private static MBeanServer mbs = ManagementFactory.getPlatformMBeanServer();
    private static ObjectName name;
    static {
        try {
            name = new ObjectName("java.nio:type=BufferPool,name=direct");
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    
    private static void reportNativeBufferUsage(long current) throws Exception {
        if( current % 1000 == 0) {
            Long total = (Long) mbs.getAttribute(name, "TotalCapacity");
            Long used = (Long) mbs.getAttribute(name, "MemoryUsed");
            Long count = (Long) mbs.getAttribute(name, "Count");
    
            // report native buffer usage
            log.infof("invoked=%,d, total=%,d, used=%,d, count=%,d", current, total, used, count);
        }
    }

}
